// Author : Luc Jaulin
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "box.h"
#include "repere.h"
#include "main.h"
#include "iboolean.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{   P0=box(2);
    P0[1]=interval(-10,10);	P0[2]=interval(-10,10);
    noise=interval(-0.0002,0.0002);
}
//---------------------------------------------------------------------------
void TForm1::Init()
{   //Button1->Visible=false;

    R1=repere(Image1,Inf(P0[1]),Sup(P0[1]),Inf(P0[2]),Sup(P0[2]));
    R_traj=repere(Image2,Inf(P0[1]),Sup(P0[1]),Inf(P0[2]),Sup(P0[2]));
    R_map=repere(Image3,Inf(P0[1]),Sup(P0[1]),Inf(P0[2]),Sup(P0[2]));
    R_pose=repere(Image4,Inf(P0[1]),Sup(P0[1]),Inf(P0[2]),Sup(P0[2]));
    R_error=repere(Image5,0,k_max,0,12);
    k_file=0;
    eps=0.02;
    Map=paving(P0,iperhaps);
}
//---------------------------------------------------------------------------
char* fgets2(FILE* f,char* line)   //Afin d'ignorer les lignes qui commencent par %
{ char* r;
  do   { r=fgets(line,256,f);}  while (((line[0]=='%')||(line[1]=='%'))&&(r!= NULL));
  return r;
}
//---------------------------------------------------------------------------
void TForm1::readdata()
{   X.clear();Y.clear();Theta.clear();V.clear();
    x.clear();y.clear();theta.clear();v.clear();u1.clear(); u2.clear();d.clear();;
    cercles_x.clear();cercles_y.clear();cercles_r.clear();;
    murs_xa.clear();murs_xb.clear();murs_ya.clear();murs_yb.clear();
    FILE *fdata;
    char line[256];
    if (testcase==1)  fdata = fopen("data1.txt","r");
    if (testcase==2)  fdata = fopen("data2.txt","r");
    int k1;
    double x1,y1,theta1,v1,u11,u21,d1;
    fgets2(fdata,line);
    sscanf(line,"%d",&N_cercles);
    for (int i=0;i<N_cercles;i++)
    {  double cercles_x1,cercles_y1,cercles_r1;
       fgets2(fdata,line);
       sscanf(line,"%lf%lf%lf",&cercles_x1,&cercles_y1,&cercles_r1);
       cercles_x.push_back(cercles_x1);cercles_y.push_back(cercles_y1);cercles_r.push_back(cercles_r1);
    }
    fgets2(fdata,line);
    sscanf(line,"%d",&N_murs);
    for (int i=0;i<N_murs;i++)
    {  double murs_xa1,murs_xb1,murs_ya1,murs_yb1;
       fgets2(fdata,line);
       sscanf(line,"%lf%lf%lf%lf",&murs_xa1,&murs_ya1,&murs_xb1,&murs_yb1);
       murs_xa.push_back(murs_xa1);murs_ya.push_back(murs_ya1);murs_xb.push_back(murs_xb1);murs_yb.push_back(murs_yb1);
    }

    while (fgets2(fdata,line) != NULL)
      {
         sscanf(line,"%d%lf%lf%lf%lf%lf%lf%lf%",&k1,&x1,&y1,&theta1,&v1,&u11,&u21,&d1);
         x.push_back(x1);y.push_back(y1);theta.push_back(theta1);v.push_back(v1);
         u1.push_back(u11);u2.push_back(u21);d.push_back(d1);
         X.push_back(interval(-oo,oo));Y.push_back(interval(-oo,oo));Theta.push_back(theta1+noise);V.push_back(v1+noise);
    }
    k_max=x.size();
    TrackBar1->Max=k_max-1;
    fclose(fdata);
    X[0]=interval(x[0]);  // the initial condition is known
    Y[0]=interval(y[0]);

    Memo1->Text="Fin du chargement des fichiers";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonTestCase1Click(TObject *Sender)
{     testcase=1;
      readdata();
      Init();
      eps=0.4;
      Contract_Traj();
      Contract_Map();
      Contract_All_Poses();
      eps=0.2;
      Contract_Traj();
      Contract_Map();
      Contract_All_Poses();
      eps=0.1;
      Contract_Traj();
      Contract_Map();
      Contract_All_Poses();
      eps=0.05;
      Contract_Traj();
      Contract_Map();
      Contract_All_Poses();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{   box XY=box(X[k_current],Y[k_current]);
    if (TrackBar1->Position>=k_max)   TrackBar1->Position=k_max-1;
    k_current= TrackBar1->Position ;
    XY=box(X[k_current],Y[k_current]);
    //R_traj.DrawCadre(XY,clPurple,psSolid,1);
    //R_map.DrawCadre(XY,clPurple,psSolid,1);
    //R_map.DrawPoint(x[k_current],y[k_current],clRed,1);
    Memo1->Text="k_current = "+String(k_current)+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"k_max = "+String(k_max)+" \r\n ";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonTestCase2Click(TObject *Sender)
{     testcase=2;
      readdata();
      Init();
      eps=0.4;
      Contract_Traj();
      Contract_Map();
      Contract_All_Poses();
      eps=0.2;
      Contract_Traj();
      Contract_Map();
      Contract_All_Poses();
      eps=0.1;
      Contract_Traj();
      Contract_Map();
      Contract_All_Poses();
      eps=0.05;
      Contract_Traj();
      Contract_Map();
      Contract_All_Poses();
}
//---------------------------------------------------------------------------

